unit u_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, ToolWin, ComCtrls, ExtCtrls, StdCtrls, FileCtrl,
  Buttons, ImgList,
  CTLibQuery,CTLibDatabase, CTLibBulk;

type
  Tf_main = class(TForm)
    main_menu: TMainMenu;
    Exit1: TMenuItem;
    tb_main: TToolBar;
    menu_serverbox1: TPopupMenu;
    mnu_connect: TMenuItem;
    mnu_disconnect: TMenuItem;
    StatusBar: TStatusBar;
    Panel1: TPanel;
    serverbox1: TTreeView;
    Splitter2: TSplitter;
    DirectoryListBox: TDirectoryListBox;
    FileListBox: TFileListBox;
    CTLibBulk: TCTLibBulk;
    CTLibQuery: TCTLibQuery;
    lv_files: TListView;
    SaveDialog1: TSaveDialog;
    Panel2: TPanel;
    DriveComboBox1: TDriveComboBox;
    FilterComboBox1: TFilterComboBox;
    Splitter3: TSplitter;
    Options1: TMenuItem;
    Help1: TMenuItem;
    Contents1: TMenuItem;
    N1: TMenuItem;
    About1: TMenuItem;
    Stop1: TMenuItem;
    ToolButton1: TToolButton;
    ToolButton4: TToolButton;
    btn_close: TSpeedButton;
    btn_stop: TSpeedButton;
    btn_options: TSpeedButton;
    Server1: TMenuItem;
    Connect1: TMenuItem;
    Disconnect1: TMenuItem;
    btn_connect: TSpeedButton;
    btn_disconnect: TSpeedButton;
    ToolButton2: TToolButton;
    ImageList1: TImageList;
    ToolButton3: TToolButton;
    btn_help: TSpeedButton;
    procedure Exit1Click(Sender: TObject);
    procedure serverbox1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure FileListBoxChange(Sender: TObject);
    procedure get_servers;
    procedure init_servers;
    procedure get_databases(adatabase:tctlibdatabase;node :ttreenode; serverbox:TTreeView);
    procedure serverbox1Expanded(Sender: TObject; Node: TTreeNode);
    procedure serverbox1Expanding(Sender: TObject; Node: TTreeNode;
      var AllowExpansion: Boolean);
    procedure mnu_connectClick(Sender: TObject);
    procedure mnu_disconnectClick(Sender: TObject);
    procedure get_list_view(node :ttreenode;
                            serverbox:TTreeView;
                            dbname:string;
                            query:tctlibquery);
    procedure serverbox1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure serverbox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FileListBoxDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure serverbox1DragDrop(Sender, Source: TObject; X, Y: Integer);
    function validnode(node:ttreenode):boolean;
    procedure CTLibBulkAfterRow(Sender: TObject);
    procedure lv_filesClick(Sender: TObject);
    procedure lv_filesDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure lv_filesDragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure btn_closeClick(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure CTLibBulkAfterCopy(Sender: TObject);
    procedure Options1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure About1Click(Sender: TObject);
  private
    character_format     :Boolean;
    native_format        :Boolean;
    none_format          :Boolean;
    background           :Boolean;
    fieldterminator      :String;
    rowterminator        :String;
    working_directory    :String;
    last_user            :String;
    batchsize            :Cardinal;
    firstrow             :Cardinal;
    lastrow              :Cardinal;
    isvalidfile          :Boolean;
    serverlist           :TStrings;
    databases            :TList;
    query                :TCTLibQuery;
    source_id            :SmallInt;  // 1 = Server 2 = File
    CountLabel           :TLabel;
    DispLabel            :TLabel;
    TargetFile           :String;
    function CanCopy :Boolean;
    procedure Write_Ini;
    procedure Read_Ini;
  public
    { Public declarations }
  end;

var
  f_main    :Tf_main;

implementation
uses IniFiles,
     u_options;
{$R *.DFM}

procedure Tf_main.Exit1Click(Sender: TObject);
var i    :Integer;
begin
  if CanCopy then
  begin
    for i:=0 to databases.COunt-1 do
      TCtLibDatabase(databases[i]).Disconnect;
    Write_Ini;  
    close;
  end;
end;

procedure Tf_main.serverbox1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
var Tn    :TTreeNode;
begin
  accept:=false;
  Tn:=serverbox1.GetNodeAt(X, Y);
  if Tn = nil then
    exit;
  if (source=lv_files)
       and (isvalidfile)
       and (Tn.Level=4) then
    accept:=true
  else
    accept:=false;
end;

procedure Tf_main.init_servers;
var i           :integer;
    database    :tctlibdatabase;
begin
  serverbox1.items[0].selectedindex:=0;

  for i:=0 to serverlist.count-1 do
  begin
    serverbox1.items.addchild(serverbox1.items[0],serverlist[i]);
    serverbox1.items[0][i].selectedindex:=1;
    serverbox1.items.addchild(serverbox1.items[0][i],'Databases');

    database:=tctlibdatabase.create(self);
    database.servername:=serverlist[i];
    database.name:='db_' + serverlist[i];
    database.dbname:='master';
    database.username:='sa';
    database.ConProps:=database.ConProps + [cpBulk_Login];
    databases.add(database);
  end;
  if serverlist.count>0 then
  begin
    serverbox1.items[0].expanded:=true;
  end;

end;

procedure Tf_main.FileListBoxChange(Sender: TObject);
var i     :integer;
    lit   :TListItem;
begin
  if filelistbox.Items.Count=0 then
    isvalidfile:=false;

  lv_files.Items.Clear;  
  for i:=0 to FileListBox.items.count-1 do
  begin
    with lv_files.Items.Add do
      Caption:=FileListBox.Items[i]
  end;
end;

procedure Tf_main.get_servers;
var sybase_dir  :array[0..255] of char;
    fin         :textfile;
    l           :string;
    l2          :string[1];
begin
    GetEnvironmentVariable('SYBASE',sybase_dir,sizeof(sybase_dir));
    l:=string(sybase_dir) + '\INI\SQL.INI';
    try
    assignfile(fin,l);
    {$i-} reset(fin) {$i+};
    if (ioresult=0) then
    begin
      while not eof(fin) do
      begin
        readln(fin,l);
        l2:=l;
        if l2='[' then
        begin
          serverList.add(copy(l,2,length(l)-2));
        end;
      end;
    end;
    finally
     {$i-} closefile(fin) {$I+};
    end;
end;

procedure Tf_main.get_databases(adatabase:tctlibdatabase; node :ttreenode; serverbox:TTreeView);
var dbcnt      :integer;
    i,j        :integer;
    databases  :array[1..50] of string[30];
begin
  CountLabel.parent:=nil;
  query.dbname:=adatabase.name;
  query.sql:='select name from master..sysdatabases order by name';
  query.sqlexec;
  dbcnt:=0;
  while query.nextrow = 1 do
  begin
    serverbox.items.addchild(node.item[0],query.column[1]);
    inc(dbcnt);
  end;

  if query.RowsReturned then
  begin
    node[0].expanded:=true;
  end;

  for i:=0 to node[0].count-1 do
  begin
    node[0][i].selectedindex:=2;
    get_list_view(node[0][i],
                  serverbox1,
                  node[0][i].text,
                  query);
    for j:=0 to node[0][i].count-1 do
    begin
      node[0][i][j].selectedindex:=3;
    end;
  end;
  DispLabel.Caption:='Rows Copied :                                                    ';
  DispLabel.Refresh;
  CountLabel.parent:=StatusBar;

end;

procedure Tf_main.serverbox1Expanded(Sender: TObject; Node: TTreeNode);
var adatabase :tctlibdatabase;
begin
  if node.level<>1 then
    exit;
  adatabase:=tctlibdatabase(databases[node.index]);

  if not adatabase.connected then
    node.expanded:=false;
  if (adatabase.connected)
    and (node.item[0].count=0) then
    get_databases(adatabase,node,serverbox1);
end;

procedure Tf_main.serverbox1Expanding(Sender: TObject; Node: TTreeNode;
  var AllowExpansion: Boolean);
var adatabase :tctlibdatabase;
begin
  if node.level = 1 then
  begin
    adatabase:=tctlibdatabase(databases[node.index]);
    if not adatabase.connected then
    begin
      adatabase.UserName:=last_user;
      adatabase.connect;
      last_user:=adatabase.UserName;
    end;
  end;
end;

procedure Tf_main.mnu_connectClick(Sender: TObject);
var adatabase :tctlibdatabase;
begin
  if serverbox1.selected.level = 1 then
  begin
    adatabase.UserName:=last_user;
    adatabase:=tctlibdatabase(databases[serverbox1.selected.index]);
    if not adatabase.connected then
      adatabase.connect;
    if adatabase.connected then
      serverbox1.selected.expanded:=true;
    last_user:=adatabase.UserName;
  end;
end;

procedure Tf_main.mnu_disconnectClick(Sender: TObject);
var adatabase :tctlibdatabase;
begin
  if not CanCopy then
    exit;
  if serverbox1.selected.level = 1 then
  begin
    adatabase:=tctlibdatabase(databases[serverbox1.selected.index]);
    if adatabase.connected then
    begin
      adatabase.disconnect;
      serverbox1.selected.expanded:=false;
    end;
  end;
end;

procedure Tf_main.serverbox1Click(Sender: TObject);
begin
  source_id:=1;
end;

procedure Tf_main.get_list_view(node :ttreenode;
                                serverbox:TTreeView;
                                dbname:string;
                                query:tctlibquery);
begin
  query.sql:='select name from ' + dbname + '..sysobjects where type="U" order by name';
  query.sqlexec;
  while query.nextrow = 1 do
  begin
    DispLabel.Caption:=dbname + '..' + query.column[1] + '                                            ';
    DispLabel.Refresh;
    serverbox.items.addchild(node,query.column[1]);
  end;
  DatabaseByName(Query.DbName).CanQuery;
end;

procedure Tf_main.FormCreate(Sender: TObject);
begin
  isvalidfile:=false;
  serverlist:=tstringlist.create;
  databases:=tlist.create;
  get_servers;
  query:=tctlibquery.create(self);
  init_servers;
  source_id:=0;

  DispLabel:=TLabel.Create(StatusBar);
  DispLabel.Height:=16;
  DispLabel.Top:=6;
  DispLabel.Width:=100;
  DispLabel.Left:=10;
  DispLabel.Font.Style:=[fsBold];
  DispLabel.parent:=StatusBar;
  DispLabel.Caption:='Rows Copied :';

  CountLabel:=TLabel.Create(StatusBar);
  CountLabel.Height:=16;
  CountLabel.Top:=6;
  CountLabel.Width:=100;
  CountLabel.Left:=95;
  CountLabel.Font.Style:=[fsBold];
  CountLabel.Caption:='';
end;

procedure Tf_main.FormClose(Sender: TObject; var Action: TCloseAction);
var i             :integer;
    adatabase     :tctlibdatabase;
begin
  for i:=0 to databases.count-1 do
  begin
    adatabase:=tctlibdatabase(databases[i]);
    adatabase.disconnect;
  end;
end;

procedure Tf_main.serverbox1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if button=mbright then
  begin
    if serverbox1.selected.level = 1 then
      serverbox1.popupmenu:=menu_serverbox1
    else
      serverbox1.popupmenu:=nil;
  end;

end;

procedure Tf_main.FileListBoxDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  if (source=serverbox1) then
    accept:=true
  else
    accept:=false;
end;

procedure Tf_main.serverbox1DragDrop(Sender, Source: TObject; X,
  Y: Integer);
var targetnode          :ttreenode;
    sourcenode          :ttreenode;
    msg1                :string;
    Lit                 :TListItem;
    database            :TCTLibDatabase;
    abcp                :TCTLibBulk;
    scnt                :String[10];
    cnt                 :Integer;
    Tn                  :TTreeNode;

begin
  targetnode:=serverbox1.DropTarget;
  
  Tn:=serverbox1.GetNodeAt(X, Y);
  if Tn = nil then
    exit;

  if not validnode(targetnode) then
    exit;

  if not CanCopy then
    exit;

  case source_id of
    1:begin
        // The idea was to copy from one server to another as well
      end;
    2:begin
        TargetFile:=DirectoryListBox.Directory + '\' + lv_files.Selected.Caption;

        if MessageBox(GetActiveWindow,PChar('BCP file ' + TargetFile + ' to table "' + Tn.Text + '"'),'WinBcp',mb_yesno+mb_iconquestion) = idno then
          exit;

        Countlabel.Caption:='             ';
        Countlabel.Refresh;
        database:=tctlibdatabase(databases[Tn.parent.parent.index]);
        database.canquery;

        if not CTLibBulk.Background then
          screen.cursor:=crSQLWait
        else
          screen.cursor:=crAppStart;
        try
          database.DBName:=Tn.parent.Text;
          CTLibBulk.DbName:=database.Name;
          CTLibBulk.DataFile:=TargetFile;

          CTLibBulk.TableName:=Tn.Text;
          CTLibBulk.Direction:=bdIn;
          CTLibBulk.BulkCopy;
        finally
          if not CTLibBulk.Background then
            screen.cursor:=crDefault;
        end;
      end;
    end;
end;

function Tf_main.validnode(node:ttreenode):boolean;
begin
  if node.level<>4 then
  begin
    MessageBox(GetActiveWindow,pchar(node.text + ' is not a table!'),'BCP error',mb_ok+mb_iconexclamation);
    result:=false;
  end
  else
    result:=true;
end;

procedure Tf_main.CTLibBulkAfterRow(Sender: TObject);
var i   :integer;
begin
  CountLabel.Caption:=inttostr(CTLibBulk.RowsCopied);
  CountLabel.Refresh;
end;

procedure Tf_main.lv_filesClick(Sender: TObject);
begin
  if lv_files.selcount = 0 then
    exit;

  isvalidfile:=true;
  source_id:=2;
end;

procedure Tf_main.lv_filesDragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  if (source=serverbox1)
    and (serverbox1.Selected.Level = 4) then
    accept:=true
  else
    accept:=false;
end;

procedure Tf_main.lv_filesDragDrop(Sender, Source: TObject; X, Y: Integer);
var targetnode       :ttreenode;
    sourcenode       :ttreenode;
    database         :tctlibdatabase;
    abcp             :tctlibbulk;
    scnt             :string[10];
    cnt              :integer;
    Lit              :TListItem;

begin
  targetnode:=serverbox1.DropTarget;

  if not CanCopy then
    exit;

  Lit:=lv_files.GetItemAt(x, y);

  if Lit = nil then
  begin
    if SaveDialog1.Execute then
      TargetFile:=SaveDialog1.FileName
    else
      exit;
  end
  else
    TargetFile:=DirectoryListBox.Directory + '\' + Lit.Caption;

//  if not validnode(targetnode) then
//    exit;

  case source_id of
    1:begin
        sourcenode:=serverbox1.Selected;
        if not validnode(sourcenode) then
          exit;

        if MessageBox(GetActiveWindow,PChar('BCP table "' + sourcenode.text + '" to ' + TargetFile),'WinBcp',mb_yesno+mb_iconquestion) = idno then
         exit;

        database:=tctlibdatabase(databases[serverbox1.Selected.parent.parent.index]);
        Countlabel.Caption:='               ';
        Countlabel.Refresh;

        if not CTLibBulk.Background then
          screen.cursor:=crSQLWait
        else
          screen.cursor:=crAppStart;
        try
          database.canquery;
          database.DBName:=serverbox1.Selected.parent.Text;

          CTLibBulk.DbName:=database.Name;
          CTLibBulk.DataFile:=TargetFile;
          CTLibBulk.TableName:=sourcenode.text;
          CTLibBulk.Direction:=bdOut;
          CTLibBulk.BulkCopy;
          FileListBox.Update;
        finally
        if not CTLibBulk.Background then
           screen.cursor:=crDefault;
      end;
   end;
 end;

end;

procedure Tf_main.btn_closeClick(Sender: TObject);
begin
  Close;
end;

function Tf_main.CanCopy: Boolean;
begin
  result:=True;
  if CTLibBulk.Busy then
    if MessageBox(GetActiveWindow,PChar('BCP still in progress. Cancel BCP'),'WinBcp',mb_yesno+mb_iconquestion) = idno then
      result:=False
    else
      CTLibBulk.StopCopy
end;

procedure Tf_main.Stop1Click(Sender: TObject);
begin
  CanCopy;
end;

procedure Tf_main.CTLibBulkAfterCopy(Sender: TObject);
begin
  screen.cursor:=crDefault;
  DirectoryListBox.Refresh;
  serverbox1.Refresh;
  screen.cursor:=crDefault;
  beep;
end;

procedure Tf_main.Options1Click(Sender: TObject);
begin
  f_options:=Tf_options.Create(Self);

  f_options.rb_character.Checked:=character_format;
  f_options.rb_native.Checked:=native_format;
  f_options.rb_none.Checked:=none_format;
  f_options.chk_background.Checked:=background;
  f_options.e_fieldterminator.Text:=fieldterminator;
  f_options.e_rowterminator.Text:=rowterminator;
  f_options.e_working_directory.Text:=working_directory;
  f_options.e_batchsize.text:=IntToStr(batchsize);
  f_options.e_firstrow.text:=IntToStr(firstrow);
  f_options.e_lastrow.text:=IntToStr(lastrow);

  f_options.showmodal;

  character_format:=f_options.rb_character.Checked;
  native_format:=f_options.rb_native.Checked;
  none_format:=f_options.rb_none.Checked;
  background:=f_options.chk_background.Checked;
  fieldterminator:=f_options.e_fieldterminator.Text;
  rowterminator:=f_options.e_rowterminator.Text;
  working_directory:=f_options.e_working_directory.Text;
  batchsize:=strtoint(trim(f_options.e_batchsize.text));
  firstrow:=strtoint(trim(f_options.e_firstrow.text));
  lastrow:=strtoint(trim(f_options.e_lastrow.text));

  CTLibBulk.Background:=background;
  CTLibBulk.FieldTerminator:=fieldterminator;
  CTLibBulk.RowTerminator:=rowterminator;
  CTLibBulk.BatchSize:=batchsize;
  CTLibBulk.FirstRow:=firstrow;
  CTLibBulk.LastRow:=lastrow;
  if character_format then
    CTLibBulk.Format:=bcCharacter;
  if native_format then
    CTLibBulk.Format:=bcNative;
  if none_format then
    CTLibBulk.Format:=bcNone;

  f_options.Free;
  write_ini;
end;

procedure Tf_main.Write_Ini;
var WinBcpIni  :TIniFile;
begin
  WinBcpIni := TIniFile.Create(extractfilepath(application.ExeName) + 'WinBcp.Ini');
  with WinBcpIni do
  begin
    WriteBool('Format', 'Character',character_format);
    WriteBool('Format', 'Native',native_format);
    WriteBool('Format', 'None',none_format);
    WriteBool('General', 'Background',background);
    writestring('General', 'FieldTerminator',fieldterminator);
    writestring('General', 'RowTerminator',rowterminator);
    writestring('General', 'WorkingDirectory',working_directory);
    writestring('General', 'LastUser',last_user);
    writeinteger('General', 'BatchSize',batchsize);
    writeinteger('General', 'FirstRow',firstrow);
    writeinteger('General', 'LastRow',lastrow);
  end;
  WinBcpIni.Free;
end;

procedure Tf_main.Read_Ini;
var WinBcpIni  :TIniFile;
begin
  WinBcpIni := TIniFile.Create(extractfilepath(application.ExeName) + 'WinBcp.Ini');
  with WinBcpIni do
  begin
    character_format:=ReadBool('Format', 'Character',True);
    native_format:=ReadBool('Format', 'Native',False);
    none_format:=ReadBool('Format', 'None',False);
    background:=ReadBool('General', 'Background',False);
    fieldterminator:=Readstring('General', 'FieldTerminator','');
    rowterminator:=Readstring('General', 'RowTerminator','');
    working_directory:=Readstring('General', 'WorkingDirectory',extractfilepath(application.ExeName));
    last_user:=Readstring('General', 'LastUser','');
    batchsize:=Readinteger('General', 'BatchSize',1000);
    firstrow:=Readinteger('General', 'FirstRow',0);
    lastrow:=Readinteger('General', 'LastRow',0);
  end;
  WinBcpIni.Destroy;
  
  CTLibBulk.Background:=background;
  CTLibBulk.FieldTerminator:=fieldterminator;
  CTLibBulk.RowTerminator:=rowterminator;
  CTLibBulk.BatchSize:=batchsize;
  CTLibBulk.FirstRow:=firstrow;
  CTLibBulk.LastRow:=lastrow;
  if character_format then
    CTLibBulk.Format:=bcCharacter;
  if native_format then
    CTLibBulk.Format:=bcNative;
  if none_format then
    CTLibBulk.Format:=bcNone;

end;

procedure Tf_main.FormActivate(Sender: TObject);
begin
  Read_Ini;
end;

procedure Tf_main.About1Click(Sender: TObject);
begin
  MessageBox(GetActiveWindow,PChar('WinBcp by Stephan Marais, 1999. <fmarais@idt.net>'),'WinBcp',mb_ok+mb_iconinformation)
end;

end.
